*==============================================================================
* Program:				ADDPK.PRG
* Purpose:				Add a primary key and populate it
* From:				    Practical Tips for Working with Existing Code
* Copyright:			(c) 2007 Tamar E. Granor, Ph.D.
* Last revision:		03/21/07
*==============================================================================
*PROCEDURE AddPK
LPARAMETERS cTable, cField

IF FILE(FORCEEXT(cTable, "DBF"))
	SELECT 0
	USE (cTable) EXCLUSIVE ALIAS __AddPK
	IF TYPE(cField) <> "N"
		* Add it
		ALTER TABLE (cTable) ADD (cField) I
		
		* Populate it
		REPLACE ALL (cField) WITH RECNO()
		
		GO BOTTOM 
		STORE EVALUATE(cField) TO nLastID 
		
		* Make it auto-increment
		IF NOT EMPTY(CURSORGETPROP("Database","__AddPK"))
			ALTER TABLE (cTable) alter (cField) I AUTOINC NEXTVALUE nLastID+1 PRIMARY KEY 
		ELSE 
			ALTER TABLE (cTable) alter (cField) I AUTOINC NEXTVALUE nLastID+1 UNIQUE 
		ENDIF 
		
	ENDIF
	
	USE IN __AddPK
ENDIF

RETURN 