*==============================================================================
* Program:				ADDANDPOPULATEFK.PRG
* Purpose:				Add a foreign key and populate it based on existing data
* From:				    Practical Tips for Working with Existing Code
* Copyright:			(c) 2007 Tamar E. Granor, Ph.D.
* Last revision:		03/21/07
*==============================================================================
LPARAMETERS cFKTable, cFKField, cPKTable, cPKField, cPKDataTag, cFKRelExp, aDropFields

LOCAL cPKFieldAliased, cDropClause

IF FILE(FORCEEXT(cFKTable, "DBF"))
	SELECT 0
	USE (cFKTable) EXCLUSIVE ALIAS __FKTable
	IF TYPE(cFKField) <> "N"
		ALTER TABLE (cFKTable) ADD (cFKField) I
		
		IF NOT EMPTY(cPKDataTag)
			USE (cPKTable) ORDER (cPKDataTag) IN 0 ALIAS __PKTable
			SET RELATION TO EVALUATE(cFKRelExp) INTO __PKTable
			cPKFieldAliased = FORCEEXT("__PKTable", cPKField)
			REPLACE ALL (cFKField) WITH EVALUATE(cPKFieldAliased) IN __FKTable
			SET RELATION TO 
		ELSE
			* No index for desired tag. Use specified expression instead
			USE (cPKTable) IN 0 ALIAS __PKTable
			* Replace aliases in expression
			cFindValue = STRTRAN(STRTRAN(cFKRelExp, cPKTable + ".", "__PKTable."), cFKTable + ".", "__FKTable.")
			REPLACE ALL (cFKField) WITH EVALUATE(cFindValue) IN __FKTable
		ENDIF 
		USE IN __PKTable

		* Index on new FK
		INDEX ON &cFKField TAG (cFKField)

		* Remove extraneous fields, taking tags along
		ATAGINFO(aTags)
		cDropClause = ""
		FOR nField = 1 TO ALEN(aDropFields,1)
			IF ASCAN(aTags,aDropFields[m.nField],-1,-1,1,7) > 0
				DELETE TAG (aDropFields[m.nField])
			ENDIF 
			cDropClause = m.cDropClause + " DROP COLUMN " + aDropFields[m.nField]
		ENDFOR
		
		IF NOT EMPTY(m.cDropClause)
			ALTER TABLE (cFKTable) &cDropClause
		ENDIF 

	ENDIF
	
	USE IN __FKTable
ENDIF 

RETURN
